Signed-off-by: Andrew Morton <akpm@osdl.org>
---

 arch/x86_64/mm/init.c      |    5 -----
 include/asm-x86_64/page.h  |    4 +++-
 include/asm-x86_64/proto.h |    2 --
 3 files changed, 3 insertions(+), 8 deletions(-)

diff -puN arch/x86_64/mm/init.c~x86_64-flatmem-end-pfn arch/x86_64/mm/init.c
--- devel/arch/x86_64/mm/init.c~x86_64-flatmem-end-pfn	2005-09-07 20:10:24.000000000 -0700
+++ devel-akpm/arch/x86_64/mm/init.c	2005-09-07 20:10:24.000000000 -0700
@@ -411,11 +411,6 @@ void __init mem_init(void)
 #ifdef CONFIG_NUMA
 	totalram_pages = numa_free_all_bootmem();
 #else
-
-#ifdef CONFIG_FLATMEM
-	max_mapnr = end_pfn;
-	if (!mem_map) BUG();
-#endif
 	totalram_pages = free_all_bootmem();
 #endif
 	reservedpages = end_pfn - totalram_pages - e820_hole_size(0, end_pfn);
diff -puN include/asm-x86_64/page.h~x86_64-flatmem-end-pfn include/asm-x86_64/page.h
--- devel/include/asm-x86_64/page.h~x86_64-flatmem-end-pfn	2005-09-07 20:10:24.000000000 -0700
+++ devel-akpm/include/asm-x86_64/page.h	2005-09-07 20:10:24.000000000 -0700
@@ -32,6 +32,8 @@
 #ifdef __KERNEL__
 #ifndef __ASSEMBLY__
 
+extern unsigned long end_pfn;
+
 void clear_page(void *);
 void copy_page(void *, void *);
 
@@ -111,7 +113,7 @@ typedef struct { unsigned long pgprot; }
 #ifdef CONFIG_FLATMEM
 #define pfn_to_page(pfn)	(mem_map + (pfn))
 #define page_to_pfn(page)	((unsigned long)((page) - mem_map))
-#define pfn_valid(pfn)		((pfn) < max_mapnr)
+#define pfn_valid(pfn)		((pfn) < end_pfn)
 #endif
 
 #define virt_to_page(kaddr)	pfn_to_page(__pa(kaddr) >> PAGE_SHIFT)
diff -puN include/asm-x86_64/proto.h~x86_64-flatmem-end-pfn include/asm-x86_64/proto.h
--- devel/include/asm-x86_64/proto.h~x86_64-flatmem-end-pfn	2005-09-07 20:10:24.000000000 -0700
+++ devel-akpm/include/asm-x86_64/proto.h	2005-09-07 20:10:24.000000000 -0700
@@ -94,8 +94,6 @@ extern int unhandled_signal(struct task_
 extern void select_idle_routine(const struct cpuinfo_x86 *c);
 extern void swiotlb_init(void);
 
-extern unsigned long max_mapnr;
-extern unsigned long end_pfn; 
 extern unsigned long table_start, table_end;
 
 extern int exception_trace;
_
